using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Form_AttributeTypes
    /// </summary>
    public partial class T_Form_AttributeTypes
    {
        public T_Form_AttributeTypes()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_TypeId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Form_AttributeTypes");
            strSql.Append(" where F_TypeId=@F_TypeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_TypeId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Form_AttributeTypes model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Form_AttributeTypes(");
            strSql.Append("F_TypeName,F_DBTypeName,F_XMLTypeName,F_IsShow,F_DefaultLength,F_DefaultValue)");
            strSql.Append(" values (");
            strSql.Append("@F_TypeName,@F_DBTypeName,@F_XMLTypeName,@F_IsShow,@F_DefaultLength,@F_DefaultValue)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DBTypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_XMLTypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsShow", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_DefaultLength", SqlDbType.Int,4),
                    new SqlParameter("@F_DefaultValue", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.F_TypeName;
            parameters[1].Value = model.F_DBTypeName;
            parameters[2].Value = model.F_XMLTypeName;
            parameters[3].Value = model.F_IsShow;
            parameters[4].Value = model.F_DefaultLength;
            parameters[5].Value = model.F_DefaultValue;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Form_AttributeTypes model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Form_AttributeTypes set ");
            strSql.Append("F_TypeName=@F_TypeName,");
            strSql.Append("F_DBTypeName=@F_DBTypeName,");
            strSql.Append("F_XMLTypeName=@F_XMLTypeName,");
            strSql.Append("F_IsShow=@F_IsShow,");
            strSql.Append("F_DefaultLength=@F_DefaultLength,");
            strSql.Append("F_DefaultValue=@F_DefaultValue");
            strSql.Append(" where F_TypeId=@F_TypeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DBTypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_XMLTypeName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsShow", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_DefaultLength", SqlDbType.Int,4),
                    new SqlParameter("@F_DefaultValue", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TypeName;
            parameters[1].Value = model.F_DBTypeName;
            parameters[2].Value = model.F_XMLTypeName;
            parameters[3].Value = model.F_IsShow;
            parameters[4].Value = model.F_DefaultLength;
            parameters[5].Value = model.F_DefaultValue;
            parameters[6].Value = model.F_TypeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_TypeId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Form_AttributeTypes ");
            strSql.Append(" where F_TypeId=@F_TypeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_TypeId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_TypeIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Form_AttributeTypes ");
            strSql.Append(" where F_TypeId in (" + F_TypeIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Form_AttributeTypes GetModel(int F_TypeId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_TypeId,F_TypeName,F_DBTypeName,F_XMLTypeName,F_IsShow,F_DefaultLength,F_DefaultValue from T_Form_AttributeTypes ");
            strSql.Append(" where F_TypeId=@F_TypeId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_TypeId;

            CallCenterApi.Model.T_Form_AttributeTypes model = new CallCenterApi.Model.T_Form_AttributeTypes();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_TypeId"] != null && ds.Tables[0].Rows[0]["F_TypeId"].ToString() != "")
                {
                    model.F_TypeId = int.Parse(ds.Tables[0].Rows[0]["F_TypeId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_TypeName"] != null && ds.Tables[0].Rows[0]["F_TypeName"].ToString() != "")
                {
                    model.F_TypeName = ds.Tables[0].Rows[0]["F_TypeName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_DBTypeName"] != null && ds.Tables[0].Rows[0]["F_DBTypeName"].ToString() != "")
                {
                    model.F_DBTypeName = ds.Tables[0].Rows[0]["F_DBTypeName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_XMLTypeName"] != null && ds.Tables[0].Rows[0]["F_XMLTypeName"].ToString() != "")
                {
                    model.F_XMLTypeName = ds.Tables[0].Rows[0]["F_XMLTypeName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_IsShow"] != null && ds.Tables[0].Rows[0]["F_IsShow"].ToString() != "")
                {
                    model.F_IsShow = int.Parse(ds.Tables[0].Rows[0]["F_IsShow"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DefaultLength"] != null && ds.Tables[0].Rows[0]["F_DefaultLength"].ToString() != "")
                {
                    model.F_DefaultLength = int.Parse(ds.Tables[0].Rows[0]["F_DefaultLength"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_DefaultValue"] != null && ds.Tables[0].Rows[0]["F_DefaultValue"].ToString() != "")
                {
                    model.F_DefaultValue = ds.Tables[0].Rows[0]["F_DefaultValue"].ToString();
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_TypeId,F_TypeName,F_DBTypeName,F_XMLTypeName,F_IsShow,F_DefaultLength,F_DefaultValue ");
            strSql.Append(" FROM T_Form_AttributeTypes ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_TypeId,F_TypeName,F_DBTypeName,F_XMLTypeName,F_IsShow,F_DefaultLength,F_DefaultValue ");
            strSql.Append(" FROM T_Form_AttributeTypes ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Form_AttributeTypes ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_TypeId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Form_AttributeTypes T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Form_AttributeTypes";
            parameters[1].Value = "F_TypeId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}